import Component from '@glimmer/component';

export default class LineChartComponent extends Component {
  // Required params
  // @width, @height

  // Parameters w/ defaults
  get hasTopLine() {
    return this.args.hasTopLine
      ? this.args.hasTopLine
      : true
  };

  get hasRightLine() {
    return this.args.hasRightLine
      ? this.args.hasRightLine
      : true
  };

  get xLineStyle() {
    return this.args.xLineStyle
      ? this.args.xLineStyle
      : 'solid'
  };

  get yLineStyle() {
    return this.args.yLineStyle
      ? this.args.yLineStyle
      : 'dashed'
  };

  get strokeWidth() {
    return this.args.strokeWidth
      ? this.args.strokeWidth
      : '1'
  };

  get stroke() {
    return this.args.stroke
      ? this.args.stroke
      : 'lightgray'
  };

  get dashedSpacing() {
    return this.args.dashedSpacing
      ? this.args.dashedSpacing
      : '10,10'
  };

  // Number of X Lines
  get gridXCount() {
    return this.args.gridXCount
      ? this.args.gridXCount
      : 10
  };

  // Number of Y Lines
  get gridYCount() {
    return this.args.gridYCount
      ? this.args.gridYCount
      : 10
  };

  // Computed Properties
  get hasGridX() {
    return this.xLineStyle !== 'none' && this.gridXLines
  };

  get hasGridY() {
    return this.yLineStyle !== 'none' && this.gridYLines
  };

  get gridXLines() {
    const divisions = this.args.height / this.gridXCount
    return Array.from(
      {length: this.hasTopLine ? this.gridXCount : this.gridXCount - 1},
      (_, i) => Math.ceil(divisions * (this.hasTopLine ? i : i + 1)) + 1
    )
  };

  get gridYLines() {
    const divisions = this.args.width / this.gridYCount
    return Array.from(
      {length: this.hasRightLine ? this.gridYCount : this.gridYCount - 1},
      (_, i) => {
        return Math.ceil(divisions * (i + 1)) - this.strokeWidth
      }
    )
  };

  generateLines(dimension, count, includeLast) {
    const divisions = dimension / count
    return Array.from(
      {length: includeLast ? count : count - 1},
      (_, i) => Math.floor(divisions * (i + 1))
    )
  }
}